/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//機能名称 
//		  CMI Valueバッファ クラス
//変更履歴
//			  2003.11.24	zcj  新規作成
//
package jp.co.ntt.lms.lo.scorm.cbtcom;

/**
 * CMI Valueバッファ クラス <BR>
 * @author zhaicj
 * 
 */
public class CMIValueBuffer {
	
	/**
	 * リンクカウント
	 */
	private static int m_linkCount;
	
	/**
	 * ローカル値
	 */
	private String m_localValue = null;
	
	/**
	 * レッスン値
	 */
	private String m_lessonValue = null;
	
	/**
	 * ローカル値ヌル
	 */
	private boolean m_localisNull;
	
	/**
	 * レッスン値ヌル
	 */
	private boolean m_lessonisNull;

	/**
	 * コンストラクタ<br>
	 */
	public CMIValueBuffer() {
		// ローカル値
		m_localValue = "";
		// レッスン値	
		m_lessonValue = "";
		// ローカル値ヌル
		m_localisNull = true;	
		// レッスン値ヌル
		m_lessonisNull = true;
		m_linkCount = 0;

		incLinkValueBuffer();
	}
 
	/**
	 * クラスの終了処理 <BR>
	 */
	public void finalize() {
		m_linkCount = 0;
		m_localValue = null;
		m_lessonValue = null;
	}
	
	/**
	 * CMI値バッファのリンク数をインクリメントする。
	 * <br>
	 */
	public void incLinkValueBuffer() {
		m_linkCount++;
	}

	/**
	 * CMI値バッファのリンク数をデクリメントする。<br>
	 * @return boolean デクリメントした結果が０より大きいならtrue、<br>
	 *                  ０、または０より小さいならfalse
	 */
	public boolean decLinkValueBuffer() {
		m_linkCount--;
		boolean boolbuffer = (m_linkCount > 0) ? false : true;
		return boolbuffer;	
	}
	
	/**
	 * LocalValue を設定する。<BR>
	 * @param strLocalValue String ローカル値
	 */ 
	public void setLocalValue(String strLocalValue) {
		m_localValue = strLocalValue;
	}
	
	/**
	 * LessonValue を設定する。<BR>
	 * @param strLessonValue String レッスン（セッション）値 
	 */ 
	public void setLessonValue(String strLessonValue) {
		m_lessonValue = strLessonValue;
	}
	
	/**
	 * LocalIsNull を設定する。<BR>
	 * @param boolIsNull boolean ローカル値が未設定ならtrue、設定済みならfalse<br>
	 */ 
	public void setLocalIsNull(boolean boolIsNull) {
		m_localisNull = boolIsNull;
	}
	
	/**
	 * LessonIsNull を設定する。<BR>
	 * @param booIsNull boolean レッスン値が未設定ならtrue、設定済みならfalse<br>
	 */ 
	public void setLessonIsNull(boolean booIsNull) {
		m_lessonisNull = booIsNull;
	}
	
	/**
	 * LocalValue を取得する。<br>
	 * @return String ローカル値
	 */
	public String getLocalValue() {
		return m_localValue;
	}
	
	/**
	 * LessonValue を取得する。<br>
	 * @return String レッスン値
	 */
	public String getLessonValue() {
		return m_lessonValue;
	}
	
	/**
	 * LocalIsNullを取得する。<br>
	 * @return boolean ローカル値有無判定フラグ
	 */
	public boolean getLocalIsNull() {
		return m_localisNull;
	}

	/**
	 * LessonIsNullを取得する。<br>
	 * @return boolean レッスン値有無判定フラグ
	 */
	public boolean getLessonIsNull() {
		return m_lessonisNull;
	}
}